{hint: Pascal files location: ...\Greek_and_Latin_basic_word_parts\jni }
unit Greek_and_Latin_basic_word_parts_android_unit;

{$mode delphi}

interface

uses
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}

  Classes, SysUtils, AndroidWidget, actionbartab, framelayout, Laz_And_Controls,
  switchbutton, gridview, fileprovider, stablayout, sviewpager, radiogroup,
  ArraySortingFunctions, IniFiles, Math, uriparser, StringTable, And_jni,
  intentmanager;


  
type

  { TAndroidModule1 }

  TAndroidModule1 = class(jForm)
    ClearButton: jButton;
    GreekAndLatinRootsTableWebView: jWebView;
    OnlineVersionButton: jButton;
    RateAppButton: jButton;
    MoreAppsButton: jButton;
    jIntentManager1: jIntentManager;
    AboutWebView: jWebView;
    AnalyseTextButton: jButton;
    FullListSwitchButton: jSwitchButton;
    FullListTextView: jTextView;
    InputTextEdit: jEditText;
    GoodAnswerMemo: jEditText;
    jFileProvider1: jFileProvider;
    jImageView1: jImageView;
    jPanel1: jPanel;
    ChooseAnswerRadioButton1: jRadioButton;
    ChooseAnswerRadioButton2: jRadioButton;
    ChooseAnswerRadioButton3: jRadioButton;
    ChooseAnswerRadioButton4: jRadioButton;
    ChooseAnswerRadioButton5: jRadioButton;
    ChooseAnswerRadioButton6: jRadioButton;
    ChooseAnswerGroupBox: jRadioGroup;
    jsTabLayout1: jsTabLayout;
    AnswerStatisticsLabel: jTextView;
    TestLabel: jTextView;
    ChooseAnswerTextView: jTextView;
    NextButton: jButton;
    OutputTextMemo: jEditText;
    PasteButton: jButton;
    ProgressBar: jProgressBar;
    ProgressBarLabel: jTextView;
    procedure AnalyseTextButtonClick(Sender: TObject);
    procedure AndroidModule1Create(Sender: TObject);
    procedure AndroidModule1JNIPrompt(Sender: TObject);
    procedure ClearButtonClick(Sender: TObject);
    procedure FullListSwitchButtonToggle(Sender: TObject; state: boolean);
    procedure ChooseAnswerRadioButton1Click(Sender: TObject);
    procedure ChooseAnswerRadioButton2Click(Sender: TObject);
    procedure ChooseAnswerRadioButton3Click(Sender: TObject);
    procedure ChooseAnswerRadioButton4Click(Sender: TObject);
    procedure ChooseAnswerRadioButton5Click(Sender: TObject);
    procedure ChooseAnswerRadioButton6Click(Sender: TObject);
    procedure InputTextEditEnter(Sender: TObject);
    procedure jsTabLayout1TabSelected(Sender: TObject; position: integer;
      title: string);
    procedure MoreAppsButtonClick(Sender: TObject);
    procedure NextButtonClick(Sender: TObject);
    procedure OnlineVersionButtonClick(Sender: TObject);
    procedure PasteButtonClick(Sender: TObject);
    procedure RateAppButtonClick(Sender: TObject);
  private
    {private declarations}
  public
    {public declarations}
    function ARGBtoCustomColor(conv_clr: TColorRGBA): DWORD;
    procedure InitializeGreekAndLatinRootsEngine();
    procedure AnalyseInputText();

  end;

var
  AndroidModule1: TAndroidModule1;

  initialized_greek_and_latin_roots_engine:Integer;
  filename_of_Greek_and_Latin_basic_word_parts, ini_filename, ini_filepath, application_path, data_filename: TFileName;
  filename_of_Greek_and_Latin_basic_word_parts_ansi: AnsiString;
  input_uri, filename_of_Greek_and_Latin_basic_word_parts_uri: TUri;
  URI: TURI;
  ProgramIniFile: TIniFile;

  input_text_string, input_text_string_lower_case, output_text_string: String;
  input_text_memo: TStringList; //jEditText;
  greek_and_latin_roots_table_memo: TStringList; // jEditText;
//MMM  open_dialog: TOpenDialog;

  root_stringlist, found_root_stringlist, reduced_found_root_stringlist, sorted_reduced_found_root_stringlist: TStringList;
  root_index_number, found_root_index_number, reduced_found_root_index_number, sorted_reduced_found_root_index_number, index_sorted_reduced_found_root_index_number: array of Integer;
  root_index_n: Integer;
  root_found_at_position: Integer;
  skip_root: Integer;

  temp_string, temp_string_1, temp_string_2: String;
  temp_pos: Integer;
  index_of_found_substring: Integer;
  random_i, old_random_i, good_index_i, previous_good_index_i, good_answer_i, chosen_answer_i: Integer;
  number_of_bad_answers, number_of_good_answers: Integer;
  percentage_of_good_answers: Double;

  html_string: String;
  about_html_stringlist: TStringList;

  greek_and_latin_roots_table_html_string: String;

  current_tab_item, previous_tab_item: Integer;

  GreekAndLatinRootsTableStringGrid: TStringTable;

  cursor_pos_beginning : TXY;


  app_store: Integer;

const GOOGLE_STORE = 1;
const SAMSUNG_STORE = 2;
const HUAWEI_STORE = 3;
const AMAZON_STORE = 4;


const
  TAB_ITEM_NONE : Integer = 0;
  TAB_ITEM_MENU : Integer = 1;
  TAB_ITEM_ROOT_TABLE : Integer = 2;
  TAB_ITEM_TEST : Integer = 3;
  TAB_ITEM_ABOUT : Integer = 4;


implementation
  
{$R *.lfm}
  

{ TAndroidModule1 }


function TAndroidModule1.ARGBtoCustomColor(conv_clr: TColorRGBA): DWORD;
begin
  Result := (conv_clr.A shl 24) + (conv_clr.R shl 16) + (conv_clr.G shl 8) + conv_clr.B;
end;


procedure TAndroidModule1.AndroidModule1Create(Sender: TObject);
begin


//app_store := GOOGLE_STORE;
app_store := SAMSUNG_STORE;
//app_store := HUAWEI_STORE;
//app_store := AMAZON_STORE;


//MMM  DebugTabSheet.TabVisible := false;
//MMM  TextTabSheet.TabVisible := false;
//MMM  OpenButton.Visible := false;

  current_tab_item := TAB_ITEM_MENU;
  previous_tab_item := TAB_ITEM_MENU;



  //FullListLabel.Text := 'Reduced list';
  ////FullListLabel.Text := 'Full list';


  AnalyseTextButton.Text := 'Analyse ' + LineEnding + 'Text';
  PasteButton.Text := 'Paste from ' + LineEnding + 'Clipboard';


  ClearButton.Visible := True;
  PasteButton.Visible:= True;
  InputTextEdit.Visible := True;
  FullListSwitchButton.Visible := True;
  AnalyseTextButton.Visible := True;
  OutputTextMemo.Visible := False;
  ProgressBar.Visible := False;
  ProgressBarLabel.Visible := False;
  FullListTextView.Visible := True;
  jImageView1.Visible := False;
  MoreAppsButton.Visible := False;
  RateAppButton.Visible := False;
  OnlineVersionButton.Visible := False;
  AboutWebView.Visible := False;
  GreekAndLatinRootsTableWebView.Visible := False;


  ChooseAnswerGroupBox.Visible := False;
  ChooseAnswerTextView.Visible := false;
  NextButton.Visible := False;
  TestLabel.Visible := False;
  ChooseAnswerTextView.Visible := False;
  GoodAnswerMemo.Visible := False;

  MoreAppsButton.Visible := False;
  RateAppButton.Visible := False;
  OnlineVersionButton.Visible := False;
  AboutWebView.Visible := False;






  AnswerStatisticsLabel.Visible := false;

  NextButton.Text := 'Start';


  initialized_greek_and_latin_roots_engine := 0;
  ProgressBar.Visible := false;
  ProgressBarLabel.Visible := false;

  TestLabel.Text := '';
  GoodAnswerMemo.Clear();

  InputTextEdit.Text := 'Enter word';


  cursor_pos_beginning.X := 0;
  cursor_pos_beginning.Y := 0;


  random_i := 0;
  old_random_i := 0;
  good_index_i := 0;
  previous_good_index_i := 0;

  number_of_bad_answers := 0;
  number_of_good_answers := 0;
  percentage_of_good_answers := 0.0;


  input_text_memo := TStringList.Create();
  greek_and_latin_roots_table_memo := TStringList.Create();

  GreekAndLatinRootsTableStringGrid := TStringTable.Create();






  TestLabel.FontSize := 50;


   //MMM open_dialog := TOpenDialog.Create(Self);

   //MMM open_dialog.Filter := 'Txt Filesor*.txt';
   //MMM open_dialog.FileName := '';
   //MMM open_dialog.FilterIndex := 1;

  root_stringlist := TStringList.Create();
  found_root_stringlist := TStringList.Create();
  reduced_found_root_stringlist := TStringList.Create();
  sorted_reduced_found_root_stringlist := TStringList.Create();

  root_index_n := 0;

//MMM    DebugStringGrid.ColCount := 5;
    GreekAndLatinRootsTableStringGrid.ColCount := 5;

//MMM    DebugStringGrid.RowCount := 3;
//   GreekAndLatinRootsTableStringGrid.RowCount := 3;





//  InputTextEdit.SetFocus(); //does not work


    ini_filename := ChangeFileExt( ParamStr(0), '.ini' );
    ini_filepath := ExtractFilePath(ini_filename);

{$IF Defined(DARWIN)}
filename_of_Greek_and_Latin_basic_word_parts := ExtractFilePath(ExcludeTrailingPathDelimiter(ExtractFilePath(ParamStr(0)))) + 'Resources/greek_and_latin_basic_word_parts.txt';
//{$ELSEIF Defined(WINDOWS)}

//{$ELSEIF Defined(LINUX)}
{$ELSEIF Defined(ANDROID)}
{$ELSE}
    filename_of_Greek_and_Latin_basic_word_parts := ChangeFileExt(ParamStr(0), '.txt');
{$IFEND}


{
  try
   ProgramIniFile := TIniFile.Create(ini_filename);

  //maximum_field_length := ProgramIniFile.ReadInteger( 'System', 'maximum_field_length',  16384);

  finally
   ProgramIniFile.Free;
  end;
}



end;

procedure TAndroidModule1.AndroidModule1JNIPrompt(Sender: TObject);
begin

//Self.jsTabLayout1.SetBackgroundToPrimaryColor();
//Self.jsTabLayout1.SetElevation(20);
Self.jsTabLayout1.SetSelectedTabIndicatorHeight(3);
Self.jsTabLayout1.SetSelectedTabIndicatorColor(colbrLime);

Self.jsTabLayout1.AddTab('Menu');
//Self.jsTabLayout1.AddTab('Greek and Latin roots table');
Self.jsTabLayout1.AddTab('Table');
Self.jsTabLayout1.AddTab('Test');
Self.jsTabLayout1.AddTab('About');



end;

procedure TAndroidModule1.ClearButtonClick(Sender: TObject);
begin

  OutputTextMemo.Clear();
  InputTextEdit.Clear();
  InputTextEdit.SetFocus();
  InputTextEdit.ShowSoftInput();

end;

procedure TAndroidModule1.FullListSwitchButtonToggle(Sender: TObject;
  state: boolean);
begin

AnalyseTextButtonClick(Self);

end;

procedure TAndroidModule1.ChooseAnswerRadioButton1Click(Sender: TObject);
begin


chosen_answer_i := 0;

if(chosen_answer_i = good_answer_i) then
begin
ChooseAnswerGroupBox.Visible := false;
ChooseAnswerTextView.Visible := false;
GoodAnswerMemo.Visible := true;
number_of_good_answers := number_of_good_answers + 1;
end
else
begin
number_of_bad_answers := number_of_bad_answers  + 1;;
end;

percentage_of_good_answers := RoundTo(100.0*number_of_good_answers /  (number_of_bad_answers + number_of_good_answers), 0);
AnswerStatisticsLabel.Text := 'Answer statistics: ' + IntToStr(number_of_bad_answers) + ' incorrect; ' + IntToStr(number_of_good_answers) + ' correct; ' + FloatToStr(percentage_of_good_answers) + ' % percentage of correct answers.';


end;

procedure TAndroidModule1.ChooseAnswerRadioButton2Click(Sender: TObject);
begin


chosen_answer_i := 1;

if(chosen_answer_i = good_answer_i) then
begin
ChooseAnswerGroupBox.Visible := false;
ChooseAnswerTextView.Visible := false;
GoodAnswerMemo.Visible := true;
number_of_good_answers := number_of_good_answers + 1;
end
else
begin
number_of_bad_answers := number_of_bad_answers  + 1;;
end;

percentage_of_good_answers := RoundTo(100.0*number_of_good_answers /  (number_of_bad_answers + number_of_good_answers), 0);
AnswerStatisticsLabel.Text := 'Answer statistics: ' + IntToStr(number_of_bad_answers) + ' incorrect; ' + IntToStr(number_of_good_answers) + ' correct; ' + FloatToStr(percentage_of_good_answers) + ' % percentage of correct answers.';


end;

procedure TAndroidModule1.ChooseAnswerRadioButton3Click(Sender: TObject);
begin

chosen_answer_i := 2;

if(chosen_answer_i = good_answer_i) then
begin
ChooseAnswerGroupBox.Visible := false;
ChooseAnswerTextView.Visible := false;
GoodAnswerMemo.Visible := true;
number_of_good_answers := number_of_good_answers + 1;
end
else
begin
number_of_bad_answers := number_of_bad_answers  + 1;;
end;

percentage_of_good_answers := RoundTo(100.0*number_of_good_answers /  (number_of_bad_answers + number_of_good_answers), 0);
AnswerStatisticsLabel.Text := 'Answer statistics: ' + IntToStr(number_of_bad_answers) + ' incorrect; ' + IntToStr(number_of_good_answers) + ' correct; ' + FloatToStr(percentage_of_good_answers) + ' % percentage of correct answers.';



end;

procedure TAndroidModule1.ChooseAnswerRadioButton4Click(Sender: TObject);
begin

chosen_answer_i := 3;

if(chosen_answer_i = good_answer_i) then
begin
ChooseAnswerGroupBox.Visible := false;
ChooseAnswerTextView.Visible := false;
GoodAnswerMemo.Visible := true;
number_of_good_answers := number_of_good_answers + 1;
end
else
begin
number_of_bad_answers := number_of_bad_answers  + 1;;
end;

percentage_of_good_answers := RoundTo(100.0*number_of_good_answers /  (number_of_bad_answers + number_of_good_answers), 0);
AnswerStatisticsLabel.Text := 'Answer statistics: ' + IntToStr(number_of_bad_answers) + ' incorrect; ' + IntToStr(number_of_good_answers) + ' correct; ' + FloatToStr(percentage_of_good_answers) + ' % percentage of correct answers.';


end;

procedure TAndroidModule1.ChooseAnswerRadioButton5Click(Sender: TObject);
begin

chosen_answer_i := 4;

if(chosen_answer_i = good_answer_i) then
begin
ChooseAnswerGroupBox.Visible := false;
ChooseAnswerTextView.Visible := false;
GoodAnswerMemo.Visible := true;
number_of_good_answers := number_of_good_answers + 1;
end
else
begin
number_of_bad_answers := number_of_bad_answers  + 1;;
end;

percentage_of_good_answers := RoundTo(100.0*number_of_good_answers /  (number_of_bad_answers + number_of_good_answers), 0);
AnswerStatisticsLabel.Text := 'Answer statistics: ' + IntToStr(number_of_bad_answers) + ' incorrect; ' + IntToStr(number_of_good_answers) + ' correct; ' + FloatToStr(percentage_of_good_answers) + ' % percentage of correct answers.';


end;

procedure TAndroidModule1.ChooseAnswerRadioButton6Click(Sender: TObject);
begin

chosen_answer_i := 5;

if(chosen_answer_i = good_answer_i) then
begin
ChooseAnswerGroupBox.Visible := false;
ChooseAnswerTextView.Visible := false;
GoodAnswerMemo.Visible := true;
number_of_good_answers := number_of_good_answers + 1;
end
else
begin
number_of_bad_answers := number_of_bad_answers  + 1;;
end;

percentage_of_good_answers := RoundTo(100.0*number_of_good_answers /  (number_of_bad_answers + number_of_good_answers), 0);
AnswerStatisticsLabel.Text := 'Answer statistics: ' + IntToStr(number_of_bad_answers) + ' incorrect; ' + IntToStr(number_of_good_answers) + ' correct; ' + FloatToStr(percentage_of_good_answers) + ' % percentage of correct answers.';


end;

procedure TAndroidModule1.InputTextEditEnter(Sender: TObject);
begin
  AnalyseTextButtonClick(Self);
end;




procedure TAndroidModule1.jsTabLayout1TabSelected(Sender: TObject;
  position: integer; title: string);
begin


// fast loading of the app begin
if((initialized_greek_and_latin_roots_engine = 0) and (position = 0)) then
begin
InputTextEdit.SetSelectAllOnFocus(true);
InputTextEdit.SetFocus();
//InputTextEdit.ShowSoftInput(); // does not work because Activity still not finished creating
exit;
end;
// fast loading of the app end


if(initialized_greek_and_latin_roots_engine = 0) then
begin
jsTabLayout1.Enabled := false;
InitializeGreekAndLatinRootsEngine();
jsTabLayout1.Enabled := true;
end;


if position = 0 then
begin

previous_tab_item := current_tab_item;
current_tab_item := TAB_ITEM_MENU;

if(previous_tab_item = TAB_ITEM_MENU) then
begin
 exit;
end;


ClearButton.Visible := True;
PasteButton.Visible := True;
InputTextEdit.Visible := True;
FullListSwitchButton.Visible := True;
AnalyseTextButton.Visible := True;
OutputTextMemo.Visible := False;
ProgressBar.Visible := False;
ProgressBarLabel.Visible := False;
FullListTextView.Visible := True;
jImageView1.Visible := False;
MoreAppsButton.Visible := False;
RateAppButton.Visible := False;
OnlineVersionButton.Visible := False;

GreekAndLatinRootsTableWebView.Visible := False;
AboutWebView.Visible := False;


ChooseAnswerGroupBox.Visible := False;
ChooseAnswerTextView.Visible := false;
NextButton.Visible := False;
TestLabel.Visible := False;
ChooseAnswerTextView.Visible := False;
GoodAnswerMemo.Visible := False;

MoreAppsButton.Visible := False;
RateAppButton.Visible := False;
OnlineVersionButton.Visible := False;
AboutWebView.Visible := False;






OutputTextMemo.Clear();

InputTextEdit.Text := 'Enter word';
InputTextEdit.SetFocus();
//InputTextEdit.SelectAll();

end
else if position = 1 then
begin


previous_tab_item := current_tab_item;
current_tab_item := TAB_ITEM_ROOT_TABLE;

if(previous_tab_item = TAB_ITEM_ROOT_TABLE) then
begin
 exit;
end;


ClearButton.Visible := False;
PasteButton.Visible := False;
InputTextEdit.Visible := False;
FullListSwitchButton.Visible := False;
AnalyseTextButton.Visible := False;
OutputTextMemo.Visible := False;
ProgressBar.Visible := False;
ProgressBarLabel.Visible := False;
FullListTextView.Visible := False;
jImageView1.Visible := False;


ChooseAnswerGroupBox.Visible := False;
ChooseAnswerTextView.Visible := false;
NextButton.Visible := False;
TestLabel.Visible := False;
ChooseAnswerTextView.Visible := False;
GoodAnswerMemo.Visible := False;

MoreAppsButton.Visible := False;
RateAppButton.Visible := False;
OnlineVersionButton.Visible := False;

//AboutWebView.LayoutParamHeight := lpWrapContent; // changing of height dynamically does not work, uses height from Designer

GreekAndLatinRootsTableWebView.Visible := True;
AboutWebView.Visible := False;



end
else if position = 2 then
begin


previous_tab_item := current_tab_item;
current_tab_item := TAB_ITEM_TEST;

if(previous_tab_item = TAB_ITEM_TEST) then
begin
 exit;
end;


ClearButton.Visible := False;
PasteButton.Visible := False;
InputTextEdit.Visible := False;
FullListSwitchButton.Visible := False;
AnalyseTextButton.Visible := False;
OutputTextMemo.Visible := False;
ProgressBar.Visible := False;
ProgressBarLabel.Visible := False;
FullListTextView.Visible := False;
jImageView1.Visible := False;
MoreAppsButton.Visible := False;
RateAppButton.Visible := False;
OnlineVersionButton.Visible := False;
AboutWebView.Visible := False;





ChooseAnswerGroupBox.Visible := False;
ChooseAnswerTextView.Visible := false;
NextButton.Visible := True;
TestLabel.Visible := True;
ChooseAnswerTextView.Visible := False;
GoodAnswerMemo.Visible := False;

MoreAppsButton.Visible := False;
RateAppButton.Visible := False;
OnlineVersionButton.Visible := False;

GreekAndLatinRootsTableWebView.Visible := False;
AboutWebView.Visible := False;




number_of_bad_answers := 0;
number_of_good_answers := 0;
percentage_of_good_answers := 0.0;



end
else if position = 3 then
begin

previous_tab_item := current_tab_item;
current_tab_item := TAB_ITEM_ABOUT;

if(previous_tab_item = TAB_ITEM_ABOUT) then
begin
 exit;
end;

  ClearButton.Visible := False;
  PasteButton.Visible := False;
  InputTextEdit.Visible := False;
  FullListSwitchButton.Visible := False;
  AnalyseTextButton.Visible := False;
  OutputTextMemo.Visible := False;
  ProgressBar.Visible := False;
  ProgressBarLabel.Visible := False;
  FullListTextView.Visible := False;

  jImageView1.Visible := False;
  MoreAppsButton.Visible := False;
  RateAppButton.Visible := False;
  OnlineVersionButton.Visible := False;
  AboutWebView.Visible := False;


  ChooseAnswerGroupBox.Visible := False;
  ChooseAnswerTextView.Visible := false;
  NextButton.Visible := False;
  TestLabel.Visible := False;
  ChooseAnswerTextView.Visible := False;
  GoodAnswerMemo.Visible := False;


  GreekAndLatinRootsTableWebView.Visible := False;
  AboutWebView.Visible := True;

//  AboutWebView.LayoutParamHeight := lpExact; // changing of height dynamically does not work, uses height from Designer
//  AboutWebView.LayoutParamHeight := lpThreeQuarterOfParent;
//  AboutWebView.Height := jPanel1.Height - MoreAppsButton.Height;
//  AboutWebView.Height := 500;


//  AboutWebView.Visible := True;


  MoreAppsButton.Visible := True;
  RateAppButton.Visible := True;
  OnlineVersionButton.Visible := True;
  MoreAppsButton.BringToFront();
  RateAppButton.BringToFront();
  OnlineVersionButton.BringToFront();




end;


TestLabel.Text := '';

ChooseAnswerGroupBox.Visible := false;
ChooseAnswerTextView.Visible := false;

GoodAnswerMemo.Clear();
GoodAnswerMemo.Visible := false; // sometimes does not work for unknown reason on Desktop platform
AnswerStatisticsLabel.Visible := false;
NextButton.Text := 'Start';


AnswerStatisticsLabel.Text := 'Answer statistics: ' + IntToStr(number_of_bad_answers) + ' incorrect; ' + IntToStr(number_of_good_answers) + ' correct; ' + FloatToStr(percentage_of_good_answers) + ' % percentage of correct answers.';


InputTextEdit.HideSoftInput();


end;

procedure TAndroidModule1.MoreAppsButtonClick(Sender: TObject);
begin



//jIntentManager1.SetAction(iaView);  //or 'android.intent.action.VIEW' // <<--- important to set

if(app_store = GOOGLE_STORE) then
begin
//jIntentManager1.SetDataUri(jIntentManager1.ParseUri('market://search?q=pname:'+'com.google.android.camera')); //works
//jIntentManager1.SetDataUri(jIntentManager1.ParseUri('market://dev?id=5448858571649033555')); // fails to work
//jIntentManager1.SetDataUri(jIntentManager1.ParseUri('market://developer?id=Cognaxon')); // fails to work
jIntentManager1.SetDataUri(jIntentManager1.ParseUri('https://play.google.com/store/apps/developer?id=Cognaxon')); //works
end
else if(app_store = SAMSUNG_STORE) then
begin
jIntentManager1.SetDataUri(jIntentManager1.ParseUri('http://cognaxon.com/index.php?page=download_educational'));
end
else if(app_store = HUAWEI_STORE) then
begin
jIntentManager1.SetDataUri(jIntentManager1.ParseUri('http://cognaxon.com/index.php?page=download_educational'));
end
else if(app_store = AMAZON_STORE) then
begin
jIntentManager1.SetDataUri(jIntentManager1.ParseUri('http://www.amazon.com/gp/mas/dl/android?s=Cognaxon')); //works
end
else
begin
jIntentManager1.SetDataUri(jIntentManager1.ParseUri('http://cognaxon.com/index.php?page=download_educational'));
end;



jIntentManager1.StartActivity();



end;

procedure TAndroidModule1.NextButtonClick(Sender: TObject);
begin


  NextButton.Text := 'Next';

  if(initialized_greek_and_latin_roots_engine = 0) then
  begin
  InitializeGreekAndLatinRootsEngine();
  end;

  ChooseAnswerGroupBox.Visible := true;
  ChooseAnswerTextView.Visible := true;
  GoodAnswerMemo.Visible := false;



  ChooseAnswerRadioButton1.Checked := false;
  ChooseAnswerRadioButton2.Checked := false;
  ChooseAnswerRadioButton3.Checked := false;
  ChooseAnswerRadioButton4.Checked := false;
  ChooseAnswerRadioButton5.Checked := false;
  ChooseAnswerRadioButton6.Checked := false;


  //i := root_stringlist.Count - 1; maximum value
  //int random(int num);
  //Random number generator.
  //random returns a random number between 0 and abs(num-1). random(num) is a macro defined in stdlib.h.
  //Both num and the random number returned are integers with a maximum value of LRAND_MAX.


  Randomize; // This way we generate a new sequence every time the program is run

  while(previous_good_index_i = good_index_i) do
  begin
   random_i := Random(root_stringlist.Count);
   good_index_i := random_i;
  end;

  previous_good_index_i := good_index_i;


  TestLabel.Text := root_stringlist.Strings[random_i];

  //GoodAnswerLabel.Caption := '   Root: ' + GreekAndLatinRootsTableStringGrid.Cells[0, root_index_number[random_i]] + '\n   Meaning in English: ' + GreekAndLatinRootsTableStringGrid.Cells[1, root_index_number[random_i]] + '\n   Origin language: ' + GreekAndLatinRootsTableStringGrid.Cells[2, root_index_number[random_i]] + '\n   Etymology (root origin): ' + GreekAndLatinRootsTableStringGrid.Cells[3, root_index_number[random_i]] + '\n   English examples: ' + GreekAndLatinRootsTableStringGrid.Cells[4, root_index_number[random_i]];

  GoodAnswerMemo.Clear();
  GoodAnswerMemo.AppendLn('Root: ');
  GoodAnswerMemo.AppendLn(GreekAndLatinRootsTableStringGrid.Cells[0, root_index_number[random_i]]);
  GoodAnswerMemo.AppendLn('');
  GoodAnswerMemo.AppendLn('Meaning in English: ');
  GoodAnswerMemo.AppendLn(GreekAndLatinRootsTableStringGrid.Cells[1, root_index_number[random_i]]);
  GoodAnswerMemo.AppendLn('');
  GoodAnswerMemo.AppendLn('Origin language: ');
  GoodAnswerMemo.AppendLn(GreekAndLatinRootsTableStringGrid.Cells[2, root_index_number[random_i]]);
  GoodAnswerMemo.AppendLn('');
  GoodAnswerMemo.AppendLn('Etymology (root origin): ');
  GoodAnswerMemo.AppendLn(GreekAndLatinRootsTableStringGrid.Cells[3, root_index_number[random_i]]);
  GoodAnswerMemo.AppendLn('');
  GoodAnswerMemo.AppendLn('English examples: ');
  GoodAnswerMemo.AppendLn(GreekAndLatinRootsTableStringGrid.Cells[4, root_index_number[random_i]]);

  GoodAnswerMemo.CursorPos := cursor_pos_beginning;


  random_i := Random(root_stringlist.Count);
  ChooseAnswerRadioButton1.Text := GreekAndLatinRootsTableStringGrid.Cells[1, root_index_number[random_i]];
  random_i := Random(root_stringlist.Count);
  ChooseAnswerRadioButton2.Text := GreekAndLatinRootsTableStringGrid.Cells[1, root_index_number[random_i]];
  random_i := Random(root_stringlist.Count);
  ChooseAnswerRadioButton3.Text := GreekAndLatinRootsTableStringGrid.Cells[1, root_index_number[random_i]];
  random_i := Random(root_stringlist.Count);
  ChooseAnswerRadioButton4.Text := GreekAndLatinRootsTableStringGrid.Cells[1, root_index_number[random_i]];
  random_i := Random(root_stringlist.Count);
  ChooseAnswerRadioButton5.Text := GreekAndLatinRootsTableStringGrid.Cells[1, root_index_number[random_i]];
  random_i := Random(root_stringlist.Count);
  ChooseAnswerRadioButton6.Text := GreekAndLatinRootsTableStringGrid.Cells[1, root_index_number[random_i]];


  random_i := Random(6);
  if(random_i = 0) then
  begin

  ChooseAnswerRadioButton1.Text := GreekAndLatinRootsTableStringGrid.Cells[1, root_index_number[good_index_i]];
  good_answer_i := 0;
  end
  else if(random_i = 1) then
  begin

  ChooseAnswerRadioButton2.Text := GreekAndLatinRootsTableStringGrid.Cells[1, root_index_number[good_index_i]];
  good_answer_i := 1;
  end
  else if(random_i = 2) then
  begin

  ChooseAnswerRadioButton3.Text := GreekAndLatinRootsTableStringGrid.Cells[1, root_index_number[good_index_i]];
  good_answer_i := 2;
  end
  else if(random_i = 3) then
  begin

  ChooseAnswerRadioButton4.Text := GreekAndLatinRootsTableStringGrid.Cells[1, root_index_number[good_index_i]];
  good_answer_i := 3;
  end
  else if(random_i = 4) then
  begin

  ChooseAnswerRadioButton5.Text := GreekAndLatinRootsTableStringGrid.Cells[1, root_index_number[good_index_i]];
  good_answer_i := 4;
  end
  else if(random_i = 5) then
  begin

  ChooseAnswerRadioButton6.Text := GreekAndLatinRootsTableStringGrid.Cells[1, root_index_number[good_index_i]];
  good_answer_i := 5;
  end;


  if (AnswerStatisticsLabel.Visible = false) then
  begin
  AnswerStatisticsLabel.Visible := true;
  end;

end;

procedure TAndroidModule1.OnlineVersionButtonClick(Sender: TObject);
begin


//jIntentManager1.SetAction(iaView);  //or 'android.intent.action.VIEW'
  jIntentManager1.SetDataUri(jIntentManager1.ParseUri('http://neuroclusterbrain.com/greek_and_latin_roots_finder.html'));
  jIntentManager1.StartActivity();


end;

procedure TAndroidModule1.PasteButtonClick(Sender: TObject);
begin

//MMM OpenButton.Enabled := false;
PasteButton.Enabled := false;
AnalyseTextButton.Enabled := false;
InputTextEdit.Enabled := false;



if(initialized_greek_and_latin_roots_engine = 0) then
begin
InitializeGreekAndLatinRootsEngine();
end;


InputTextEdit.PasteFromClipboard();

AnalyseTextButtonClick(Self);


//MMM OpenButton.Enabled := true;
PasteButton.Enabled := true;
AnalyseTextButton.Enabled := true;
InputTextEdit.Enabled := true;



end;

procedure TAndroidModule1.RateAppButtonClick(Sender: TObject);
begin


//jIntentManager1.SetAction(iaView);  //or 'android.intent.action.VIEW' // <<--- important to set

if(app_store = GOOGLE_STORE) then
begin
jIntentManager1.SetDataUri(jIntentManager1.ParseUri('market://details?id=com.cognaxon.Greek_and_Latin_basic_word_parts'));
//jIntentManager1.SetDataUri(jIntentManager1.ParseUri('https://play.google.com/store/apps/details?id=com.cognaxon.Greek_and_Latin_basic_word_parts'));
end
else if(app_store = SAMSUNG_STORE) then
begin
jIntentManager1.SetDataUri(jIntentManager1.ParseUri('samsungapps://AppRating/com.cognaxon.Greek_and_Latin_basic_word_parts'));
// jIntentManager1.SetDataUri(jIntentManager1.ParseUri('https://apps.samsung.com/appquery/AppRating.as?appId=com.cognaxon.Greek_and_Latin_basic_word_parts'));
end
else if(app_store = HUAWEI_STORE) then
begin
//jIntentManager1.SetDataUri(jIntentManager1.ParseUri('appmarket://details?id=com.cognaxon.Greek_and_Latin_basic_word_parts'));
jIntentManager1.SetDataUri(jIntentManager1.ParseUri('https://appgallery.cloud.huawei.com/appDetail?pkgName=com.cognaxon.Greek_and_Latin_basic_word_parts'));
end
else if(app_store = AMAZON_STORE) then
begin
//jIntentManager1.SetDataUri(jIntentManager1.ParseUri('amzn://apps/android?p=com.cognaxon.Greek_and_Latin_basic_word_parts'));
jIntentManager1.SetDataUri(jIntentManager1.ParseUri('https://www.amazon.com/gp/mas/dl/android?p=com.cognaxon.Greek_and_Latin_basic_word_parts'));
end
else
begin
jIntentManager1.SetDataUri(jIntentManager1.ParseUri('https://play.google.com/store/apps/details?id=com.cognaxon.Greek_and_Latin_basic_word_parts'));
end;



jIntentManager1.StartActivity();


//jIntentManager1.SetAction(iaView);  //or 'android.intent.action.VIEW'

{
try
  try
    //jIntentManager1.SetDataUri(jIntentManager1.ParseUri('market://search?q=pname:'+'com.google.android.camera')); //works
    jIntentManager1.SetDataUri(jIntentManager1.ParseUri('market://details?id=com.cognaxon.Greek_and_Latin_basic_word_parts'));
  except
  on E: Exception do
    jIntentManager1.SetDataUri(jIntentManager1.ParseUri('https://play.google.com/store/apps/details?id=com.cognaxon.Greek_and_Latin_basic_word_parts'));
  end;
finally
  jIntentManager1.StartActivity();
end;
}



end;




procedure TAndroidModule1.AnalyseTextButtonClick(Sender: TObject);
begin


//MMM OpenButton.Enabled := false;
PasteButton.Enabled := false;
AnalyseTextButton.Enabled := false;
InputTextEdit.Enabled := false;


if(initialized_greek_and_latin_roots_engine = 0) then
begin
InitializeGreekAndLatinRootsEngine();
end;

input_text_string := InputTextEdit.Text;


AnalyseInputText();

//MMM OpenButton.Enabled := true;
PasteButton.Enabled := true;
AnalyseTextButton.Enabled := true;
InputTextEdit.Enabled := true;




end;


procedure TAndroidModule1.InitializeGreekAndLatinRootsEngine();
var
  i, i2, i3, i4, n_col : Integer;
  temp_char: CHAR;
begin


GoodAnswerMemo.InputTypeEx := itxMultiLine;
GoodAnswerMemo.MaxTextLength := 10000;
GoodAnswerMemo.ScrollBarStyle := scrlInsideInset;
GoodAnswerMemo.MaxLines := 128;
GoodAnswerMemo.HorScrollBar := False;
GoodAnswerMemo.VerScrollBar := True;
GoodAnswerMemo.WrappingLine := True;
//GoodAnswerMemo.Enabled := False;
//GoodAnswerMemo.Editable := False;


OutputTextMemo.InputTypeEx := itxMultiLine;
OutputTextMemo.MaxTextLength := 100000;
OutputTextMemo.ScrollBarStyle := scrlInsideInset;
OutputTextMemo.MaxLines := 256;
OutputTextMemo.HorScrollBar := False;
OutputTextMemo.VerScrollBar := True;
OutputTextMemo.WrappingLine := True;
//OutputTextMemo.Enabled := False;
//OutputTextMemo.Editable := False;

//   OutputTextMemo.HideSoftInput();
//   OutputTextMemo.InputTypeEx := itxNull;
//

//OutputTextMemo.


   OutputTextMemo.SetSoftInputShownOnFocus(false); //hides keyboard
   GoodAnswerMemo.SetSoftInputShownOnFocus(false); //hides keyboard

   InputTextEdit.SetSelectAllOnFocus(true);




 //  greek_and_latin_roots_table_memo.Text:= Self.LoadFromAssetsTextContent('greek_and_latin_basic_word_parts.txt');
 //   greek_and_latin_roots_table_memo.Text:= Self.LoadFromAssetsTextContent('greek_and_latin_basic_word_parts.txt');
 // InputTextEdit.Text := IntToStr(greek_and_latin_roots_table_memo.Count);
   //jMediaPlayer1.LoadFromAssets('pipershut2.mp3');

    //jFileProvider1.FileSource:= srcResDrawable;
    //jFileProvider1.SetAuthorities('com.cognaxon.Greek_and_Latin_basic_word_parts'); //works
    //jFileProvider1.SetAuthorities(Self.PackageName);  //works
    //jImageView1.SetImage(jFileProvider1.GetImageContent('ic_launcher.png'));

    //    jFileProvider1.SetAuthorities('com.cognaxon.Greek_and_Latin_basic_word_parts');   //works
      jFileProvider1.SetAuthorities(Self.PackageName);  //works
    //  jFileProvider1.FileSource:= srcInternal;
      jFileProvider1.FileSource:= srcAssets;
    //FullListTextView.Text := jFileProvider1.GetTextContent('greek_and_latin_basic_word_parts.txt'); // works


     greek_and_latin_roots_table_memo.Clear();
     greek_and_latin_roots_table_memo.Text := jFileProvider1.GetTextContent('greek_and_latin_basic_word_parts.txt'); // works

//    InputTextEdit.Text := IntToStr(greek_and_latin_roots_table_memo.Count);


  //if (not FileExists(filename_of_Greek_and_Latin_basic_word_parts)) then
  if (greek_and_latin_roots_table_memo.Count = 0) then
  begin
   OutputTextMemo.Clear();
   OutputTextMemo.AppendLn('Error: database file' + #13#10 + 'greek_and_latin_basic_word_parts.txt' + #13#10 + 'not found.');
   OutputTextMemo.Visible := true;
   exit;
  end;



GreekAndLatinRootsTableStringGrid.RowCount := greek_and_latin_roots_table_memo.Count;



SetLength(root_index_number, 2* greek_and_latin_roots_table_memo.Count);
SetLength(found_root_index_number, 2* greek_and_latin_roots_table_memo.Count);
SetLength(reduced_found_root_index_number, 2* greek_and_latin_roots_table_memo.Count);
SetLength(sorted_reduced_found_root_index_number, 2* greek_and_latin_roots_table_memo.Count);
SetLength(index_sorted_reduced_found_root_index_number, 2* greek_and_latin_roots_table_memo.Count);


//ProgressBar.Progress:= 0;
//ProgressBar.Position := 0;
//ProgressBar.Visible := true;
//ProgressBarLabel.Visible := true;
//ProgressBarLabel.Text := 'Initializing engine....';
//ProgressBarLabel.Refresh(); // does not work


MoreAppsButton.Visible := False;
RateAppButton.Visible := False;
OnlineVersionButton.Visible := False;
AboutWebView.Visible := False;




GreekAndLatinRootsTableStringGrid.Cells[0, 0] := 'Basic word part';
GreekAndLatinRootsTableStringGrid.Cells[1, 0] := 'Meaning in English';
GreekAndLatinRootsTableStringGrid.Cells[2, 0] := 'Origin language';
GreekAndLatinRootsTableStringGrid.Cells[3, 0] := 'Etymology (basic word part origin)';
GreekAndLatinRootsTableStringGrid.Cells[4, 0] := 'English examples';



//for i := 1 to 6 do
for i := 1 to greek_and_latin_roots_table_memo.Count-1 do
begin

temp_string_1 := greek_and_latin_roots_table_memo.Strings[i];


for n_col := 0 to 4 do
begin

	temp_pos := Pos(CHR(9), temp_string_1); // Tab symbol // in mobile applications string indexes are different from desktop applications; in iOS string indexes are different from Windows

//	if (temp_pos <> -1) then //IndexOf returns -1 if not found
        if (temp_pos <> 0) then //Pos returns 0 if not found
	begin

        //{$IF Defined(ANDROID)}
        //0-based strings
        //temp_string_2 := Copy(temp_string_1, 0, temp_pos);
        //GreekAndLatinRootsTableStringGrid.Cells[n_col, i] := temp_string_2;
        //temp_string_1 := Copy(temp_string_1, (temp_pos+1), Length(temp_string_1));
        //{$ELSE}

        //1-based strings
        temp_string_2 := Copy(temp_string_1, 1, temp_pos-1);
        GreekAndLatinRootsTableStringGrid.Cells[n_col, i] := temp_string_2;
        temp_string_1 := Copy(temp_string_1, (temp_pos+1), Length(temp_string_1));

        //{$IFEND}

	end//	if (temp_pos <> 0)

        else //	else if (temp_pos = 0) then
	begin
        GreekAndLatinRootsTableStringGrid.Cells[n_col, i] := temp_string_1;

	//temp_pos := Length(temp_string_1);
	//temp_string_2 := Copy(temp_string_1, 1, temp_pos);
	//GreekAndLatinRootsTableStringGrid.Cells[n_col, i] := temp_string_2;
	//temp_string_1 := Copy(temp_string_1, (temp_pos+1), Length(temp_string_1));

	end;//else if (temp_pos = 0)




end;// for n_col := 0 to 4 do






//ProgressBar.Progress :=  i div greek_and_latin_roots_table_memo.Count * 50;
//Application.ProcessMessages(); //slows down incredibly MacOS




end;//for (int i := 0; i < greek_and_latin_roots_table_memo.Lines.Count; i++)


//ProgressBar.Progress := 50;





root_found_at_position := 0;


//for i3 := 1 to 6 do
for i3 := 1 to greek_and_latin_roots_table_memo.Count-1 do
begin

temp_string_1 := GreekAndLatinRootsTableStringGrid.Cells[0, i3];
temp_string_2 := '';

for i4 := 1 to Length(temp_string_1) do
begin

//temp_char := CHAR((AnsiString(temp_string_1))[i4]);
temp_char := CHAR((temp_string_1)[i4]);

if((temp_char >= 'a') and (temp_char <= 'z')) then
begin
root_found_at_position := 1;
temp_string_2 := temp_string_2 + String(temp_char);
end//if((temp_char >:= 'a') & (temp_char >:= 'z'))
else
begin
  if( root_found_at_position = 1) then
  begin
   root_stringlist.Add(temp_string_2);
   root_index_number[root_index_n] := i3;
   root_index_n := root_index_n + 1;
  end;//if( root_found_at_position = 1)
   temp_string_2 := '';
   root_found_at_position := 0;
end;//else -. if((temp_char >:= 'a') & (temp_char >:= 'z'))


//ProgressBar.Progress := 50 + i3 div greek_and_latin_roots_table_memo.Count * 50;
//Application.ProcessMessages(); //slows down incredibly MacOS

end;//for (int i2 := 0; i2 < temp_string_1.Length; i2++)




end;//for (int i := 0; i < greek_and_latin_roots_table_memo.Lines.Count; i++)





about_html_stringlist := TStringList.Create();
about_html_stringlist.Clear();
about_html_stringlist.Add('<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">');
about_html_stringlist.Add('<html><head><meta content="text/html; charset=ISO-8859-1" http-equiv="content-type"><title>Greek and Latin basic word parts finder</title></head>');
about_html_stringlist.Add('<br>');
about_html_stringlist.Add('<br>');
about_html_stringlist.Add('<br>');
about_html_stringlist.Add('<br>');
about_html_stringlist.Add('<br>');
about_html_stringlist.Add('<br>');
about_html_stringlist.Add('<br>');
about_html_stringlist.Add('<br>');
about_html_stringlist.Add('<br>');

about_html_stringlist.Add('<body><big><b>Greek and Latin basic word parts finder. Version ' + Self.GetVersionName() + ' (build: '+ IntToStr(Self.GetVersionCode()) + ')</b></big><br>');
about_html_stringlist.Add('<br>');
about_html_stringlist.Add('Basic word parts count = ' + IntToStr(root_stringlist.Count) + '<br>');
about_html_stringlist.Add('<br>');
about_html_stringlist.Add('Cognaxon<br>');
about_html_stringlist.Add('<a href="http://cognaxon.com">http://cognaxon.com</a><br>');
about_html_stringlist.Add('<br>');
about_html_stringlist.Add('You can increase your vocabulary without memorizing a lot of words.<br>');
about_html_stringlist.Add('Words are composed of word parts: prefixes, suffixes and roots.<br>');
about_html_stringlist.Add('A knowledge of these word parts and their meanings can help you to unlock the meaning of unfamiliar words.<br>');
about_html_stringlist.Add('Most modern English words are derived from Anglo-Saxon (Old English), Latin and Greek.<br>');
about_html_stringlist.Add('Build your vocabulary by mastering basic word parts.<br>');
about_html_stringlist.Add('Learning 30 key word parts can help you unlock the meaning of over 10,000 words.<br>');
about_html_stringlist.Add('Learning 50 key word parts can help you unlock the meaning of over 100,000 words.<br>');
about_html_stringlist.Add('<br>');
about_html_stringlist.Add('The source of data is:<br>');
about_html_stringlist.Add('<a href="https://en.wikipedia.org/wiki/List_of_Greek_and_Latin_roots_in_English">https://en.wikipedia.org/wiki/List_of_Greek_and_Latin_roots_in_English</a><br>');
about_html_stringlist.Add('List of Greek and Latin roots in English<br>');
about_html_stringlist.Add('<br>');
about_html_stringlist.Add('Full description is available at the address:<br>');
about_html_stringlist.Add('<a href="http://neuroclusterbrain.com/greek_and_latin_roots_in_english_language.html">http://neuroclusterbrain.com/greek_and_latin_roots_in_english_language.html</a><br>');
about_html_stringlist.Add('<br>');
about_html_stringlist.Add('Greek and Latin basic word parts finder compiled for Android, compilation date: ' + {$include %date%} + ', time: ' + Format('%.*d',[2, {$include %timeHour%}]) + ':' + Format('%.*d',[2, {$include %timeMinute%}]) );
about_html_stringlist.Add('</body></html>');


AboutWebView.LoadFromHtmlString(about_html_stringlist.Text);
//AboutWebView.LoadFromHtmlString('<html>Hello Android World</html>'); //works
//AboutWebView.Navigate('http://cognaxon.com'); //works


jFileProvider1.SetAuthorities(Self.PackageName);  //works
jFileProvider1.FileSource:= srcAssets;
GreekAndLatinRootsTableWebView.LoadFromHtmlString(jFileProvider1.GetTextContent('greek_and_latin_basic_word_parts_table.html'));



{
DebugStringGrid.RowCount := greek_and_latin_roots_table_memo.Lines.Count;

DebugStringGrid.RowCount := root_stringlist.Count;

for i := 0 to DebugStringGrid.RowCount - 1 do
begin
DebugStringGrid.Cells[0, i] := root_stringlist.Strings[i];
DebugStringGrid.Cells[1, i] := IntToStr(root_index_number[i]);
end;//for i := 0 to DebugStringGrid.RowCount - 1 do
}


//ProgressBar.Progress := 100;
//ProgressBar.Visible := false;
//ProgressBarLabel.Visible := false;


initialized_greek_and_latin_roots_engine := 1;


end;

procedure TAndroidModule1.AnalyseInputText();
var
 j, j2: Integer;
begin

//MMM OpenButton.Enabled := false;
PasteButton.Enabled := false;
AnalyseTextButton.Enabled := false;
InputTextEdit.Enabled := false;


//ShowMessage(IntToStr(Pos('b', 'abce')));   // == 2


OutputTextMemo.Clear();
output_text_string := '';

input_text_string_lower_case := LowerCase(input_text_string);


found_root_stringlist.Clear();
reduced_found_root_stringlist.Clear();
sorted_reduced_found_root_stringlist.Clear();

//find all root in analysed word
for j := 0 to root_stringlist.Count - 1 do
begin
   index_of_found_substring := 0;
   index_of_found_substring := Pos((root_stringlist.Strings[j]), input_text_string_lower_case);


//   if (index_of_found_substring > -1) then // found //IndexOf returns -1 if not found
   if (index_of_found_substring > 0) then // found //Pos returns 0 if not found
   begin
   found_root_stringlist.Add(root_stringlist.Strings[j]);
   found_root_index_number[found_root_stringlist.Count-1] := root_index_number[j];

   if(((root_stringlist.Strings[j] = 'a') or (root_stringlist.Strings[j] = 'e')) and (index_of_found_substring > 1)) then
   begin
   found_root_stringlist.Delete(found_root_stringlist.Count-1);
   end

   end//if (index_of_found_substring > 0) // found
end;//for(int i := 0; i < ProductStringGrid.ColumnCount; i++)




//remove shorter version of roots, leave only longer version of root
for j := 0 to found_root_stringlist.Count - 1 do
begin


if(FullListSwitchButton.IsChecked() = false) then
begin

skip_root := 0;

for j2 := 0 to found_root_stringlist.Count - 1 do
begin

   index_of_found_substring := 0;
   index_of_found_substring := Pos(found_root_stringlist.Strings[j], found_root_stringlist.Strings[j2]);
//   index_of_found_substring := Pos(found_root_stringlist.Strings[j], found_root_stringlist.Strings[j2]);

//   ShowMessage(found_root_stringlist.Strings[j]);


if ((index_of_found_substring > 0) and (Length(found_root_stringlist.Strings[j]) <> Length(found_root_stringlist.Strings[j2]))) then // found //Pos returns 0 if not found
//   if ((index_of_found_substring > -1) and (Length(found_root_stringlist.Strings[j]) <> Length(found_root_stringlist.Strings[j2]))) then // found //IndexOf returns -1 if not found
   begin
	skip_root := 1;
   end;//if ((index_of_found_substring > 0) & (Length(found_root_stringlist.Strings[j]) <> Length(found_root_stringlist.Strings[j2]))) // found

   if(found_root_stringlist.Strings[j] = 'a') then
   begin
   skip_root := 0;
   end;

   if(found_root_stringlist.Strings[j] = 'e') then
   begin
   skip_root := 0;
   end;

   if(found_root_stringlist.Strings[j] = 'de') then
   begin
   skip_root := 0;
   end;

   if(found_root_stringlist.Strings[j] = 'in') then
   begin
   skip_root := 0;
   end;

   if(found_root_stringlist.Strings[j] = 'im') then
   begin
   skip_root := 0;
   end;

   if(found_root_stringlist.Strings[j] = 'il') then
   begin
   skip_root := 0;
   end;

   if(found_root_stringlist.Strings[j] = 'ir') then
   begin
   skip_root := 0;
   end;


end;//for(int j2 := 0; j2 < found_root_stringlist.Count; j2++)

end//if(FullListCheckBox.Checked = false)
else
begin
skip_root := 0;
end;


   if(skip_root = 0) then
   begin
   reduced_found_root_stringlist.Add(found_root_stringlist.Strings[j]);
   reduced_found_root_index_number[reduced_found_root_stringlist.Count-1] := found_root_index_number[j];
   end//   if(skip_root = 0)

end;//for(int i := 0; i < ProductStringGrid.ColumnCount; i++)




//find in which place the root is located in analysed word
for j := 0 to reduced_found_root_stringlist.Count - 1 do
begin

   index_of_found_substring := 0;
   index_of_found_substring := Pos(reduced_found_root_stringlist.Strings[j], input_text_string_lower_case);
//ShowMessage(IntToStr(index_of_found_substring));
   sorted_reduced_found_root_index_number[j] := index_of_found_substring;

   index_sorted_reduced_found_root_index_number[j] := j;

end;//for(int j := 0; j < reduced_found_root_stringlist.Count; j++)

//sort found roots in the same way as they appear in the analysed word
//InSortInteger(sorted_reduced_found_root_index_number, reduced_found_root_stringlist.Count, index_sorted_reduced_found_root_index_number);
SedgeSortInteger(sorted_reduced_found_root_index_number, reduced_found_root_stringlist.Count, index_sorted_reduced_found_root_index_number);


//show final result of found roots
for j := 0 to reduced_found_root_stringlist.Count - 1 do
begin

   j2 := index_sorted_reduced_found_root_index_number[j];
//   ShowMessage(IntToStr(j2));
   root_index_n := reduced_found_root_index_number[j2];

   OutputTextMemo.AppendLn('Root: ' + reduced_found_root_stringlist.Strings[j2]);
   OutputTextMemo.AppendLn('Meaning in English: ' + GreekAndLatinRootsTableStringGrid.Cells[1, root_index_n]);
   OutputTextMemo.AppendLn('Origin language: ' + GreekAndLatinRootsTableStringGrid.Cells[2, root_index_n]);
   OutputTextMemo.AppendLn('Etymology (root origin): ' + GreekAndLatinRootsTableStringGrid.Cells[3, root_index_n]);
   OutputTextMemo.AppendLn('English examples: ' + GreekAndLatinRootsTableStringGrid.Cells[4, root_index_n]);

   OutputTextMemo.AppendLn('');
   OutputTextMemo.AppendLn('');
end;//for(int i := 0; i < ProductStringGrid.ColumnCount; i++)



//ShowMessage('Analysis completed.');


//if (output_text_string = '')
if (OutputTextMemo.Text.Length = 0) then
begin
 OutputTextMemo.AppendLn('Greek and Latin roots are not found in this text.');
end;


//????   OutputTextMemo.GoToTextBegin();

OutputTextMemo.CursorPos := cursor_pos_beginning;
OutputTextMemo.Visible := True;



//MMM OpenButton.Enabled := true;
PasteButton.Enabled := true;
AnalyseTextButton.Enabled := true;
InputTextEdit.Enabled := true;


InputTextEdit.SetFocus();
//InputTextEdit.SelectAll();
//InputTextEdit.ShowSoftInput();
InputTextEdit.HideSoftInput();


end;


end.
